unit UMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, ExBitmap;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Flipped: TCheckBox;
    Mirrored: TCheckBox;
    LoadBtn: TButton;
    Inverted: TCheckBox;
    OpenDialog1: TOpenDialog;
    BrightLabel: TLabel;
    BrightBar: TTrackBar;
    BlurBtn: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BrightBarChange(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FlippedClick(Sender: TObject);
    procedure MirroredClick(Sender: TObject);
    procedure InvertedClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure BlurBtnClick(Sender: TObject);
  private
    { Private declarations }
    bm: TExBitmap;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
    bm := TExBitmap.Create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    bm.Free;
end;

procedure TForm1.BrightBarChange(Sender: TObject);
begin
    bm.Brightness := TExBrightness (BrightBar.Position);
    BrightLabel.Caption := Format ('Brightness = %d', [bm.Brightness]);
    Image1.Picture.Bitmap.Assign (bm);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
    if not bm.Empty then Image1.Picture.Bitmap.Assign (bm);
end;

procedure TForm1.FlippedClick(Sender: TObject);
begin
    bm.Flipped := Flipped.Checked;
    Image1.Picture.Bitmap.Assign (bm);
end;

procedure TForm1.MirroredClick(Sender: TObject);
begin
    bm.Mirrored := Mirrored.Checked;
    Image1.Picture.Bitmap.Assign (bm);
end;

procedure TForm1.InvertedClick(Sender: TObject);
begin
    bm.Inverted := Inverted.Checked;
    Image1.Picture.Bitmap.Assign (bm);
end;

procedure TForm1.BlurBtnClick(Sender: TObject);
begin
    Screen.Cursor := crHourGlass;
    try
        bm.GaussianBlur;
    finally
        Screen.Cursor := crDefault;
    end;

    Image1.Picture.Bitmap.Assign (bm);
end;

procedure TForm1.LoadBtnClick(Sender: TObject);
begin
    if OpenDialog1.Execute then begin
        bm.LoadFromFile (OpenDialog1.FileName);
        Image1.Picture.Bitmap.Assign (bm);
        BrightBar.Position := bm.Brightness;
        Mirrored.Checked := bm.Mirrored;
        Flipped.Checked := bm.Flipped;
        Inverted.Checked := bm.Inverted;
    end;
end;

end.
